/* 
 * simple tpoly-to-off converter 
 *
 * If you have any interesting 3D objects/models, in any format, please
 * upload them to the anonymous ftp archive avalon.chinalake.navy.mil!!!
 */

#include <stdio.h>
#include <sys/types.h>
#include <strings.h>

static int strbpos( s, c )
char *s, c;
{
    int i = -1;
    int l = strlen( s );
    for( i=l-1; i>=0; i-- )
        if( s[i] == c )
            return i;
    return i;
}

main(argc,argv)
int argc;
char *argv[];
{
    FILE *fp;
    int i, j, k, v, vtotal, ftotal;
    float x,y,z;
    char *filename;
    char  buf[128];
    int *fnum;

    while(--argc) {
        argv++;
        if(argv[0][0] != '-')
            break;
        switch(argv[0][1]) {
        case 'h':
        case 'H':
        default:
            fprintf(stderr,"TPOLY to OFF translator\n");
            fprintf(stderr,"usage: tpoly2off TPOLY-file\n");
            exit();
            break;
        }
    }

    if(argc > 1) {
        fprintf(stderr,"TPOLY to OFF translator\n");
        fprintf(stderr,"usage: tpoly2off TPOLY-file\n");
        exit(1);
    }
    else if(argc == 1)
        filename = argv[0];
    else
        filename = "stdin";

    if(strcmp(filename, "stdin") != 0) {
        if ((fp = fopen(filename, "r")) == NULL) {
            fprintf(stderr,"failed to open input file for reading");
            exit(1);
        }
    }
    else
        fp = stdin;

    ftotal = vtotal = 0;

    while (!feof(fp)) {
        fscanf(fp,"%d",&v);
        ftotal++;
        for( j=0; j<v; j++ ) {
            vtotal++;
            fscanf(fp,"%f %f %f",&x,&y,&z);
        }
    }
    fseek(fp,(long) 0, 0);

{
    FILE *fpaoff;
    char  aoff[255];
    int   pos;

    strcpy (aoff, filename);

    pos = strbpos (aoff, '.');
    aoff[pos+1] = 'a';
    aoff[pos+2] = 'o';
    aoff[pos+3] = 'f';
    aoff[pos+4] = 'f';
    aoff[pos+5] = '\0';
    fpaoff = fopen (aoff, "w");

    aoff[pos+1] = 'g';
    aoff[pos+2] = 'e';
    aoff[pos+3] = 'o';
    aoff[pos+4] = 'm';
    aoff[pos+5] = '\0';
    fprintf (fpaoff, "\n");
    fprintf (fpaoff, "geometry\t\tindexed_poly\tfff\t%s\n", aoff);
    fprintf (fpaoff, "connect_offset\tdefault\t\t\tf\t0\n\n");
    fclose  (fpaoff);
}

    fprintf(stdout,"%d %d %d\n",vtotal,ftotal,vtotal);

    fnum = (int*)malloc( ftotal * sizeof(int) );
    ftotal = 0;

    while (!feof(fp)) {
        fscanf(fp,"%d",&v);
        fnum[ftotal++] = v;
        for( j=0; j<v; j++ ) {
            fscanf(fp,"%f %f %f",&x,&y,&z);
            fprintf(stdout,"%f %f %f\n",x,y,z);
        }
    }
    fclose(fp);

    k = 0;
    for (i=0;i<ftotal;i++) {
      fprintf(stdout,"%d ",fnum[i]);
      for (j=0;j<fnum[i];j++)
          fprintf(stdout,"%d ", ++k);
      fprintf(stdout,"\n");
    }
    free(fnum);
}
