
#ifndef _defs_h
#define _defs_h

#define OBJECT_LABEL			(long) 1
#define LIGHT_STATE_LABEL		(long) 2
#define SHADING_METHOD_LABEL	(long) 3
#define REFL_EQN_LABEL			(long) 5
#define DIR_LIGHT_LABEL			(long) 6
#define POS_LIGHT_LABEL			(long) 7
#define SPT_LIGHT_LABEL			(long) 8
#define START_LIGHT_LABEL		(long) 10
#define END_LIGHT_LABEL			(long) 11

/* Window layout information */
#define WS_WIDTH  400
#define WS_HEIGHT 400

/* Light source parameters */
#define RED_COORD			1
#define GREEN_COORD			2
#define BLUE_COORD			3
#define ATTENUATION_C1		4
#define ATTENUATION_C2		5
#define SPREAD_ANGLE		6
#define CONCENTRATION		7
#define AMBIENT_COEF		8
#define DIFFUSE_COEF		9
#define TRANSMISSION_COEF	10
#define SPECULAR_COEF		11
#define SPECULAR_EXP		12
#define POINT				13
#define DIRECTION			14

/* Light types */
#define AMBIENT        0
#define DIRECTIONAL    1
#define POSITIONAL    2
#define SPOT        3

#endif /* _defs_h */
